using System;
using Dll_CSharp_VSensorLaser;
using System.Collections.Generic;
namespace Demo.Filter
{
    public class Program
    {
        static void Main(string[] args)
        {
            try
            {
                //获取相对路径
                string path = System.IO.Directory.GetCurrentDirectory();
                //实例化设备
                VSensorLaserDLL VSensor = new VSensorLaserDLL();
                //获取设备列表
                List<VSensorLaserCameraInfoCLR> list = new List<VSensorLaserCameraInfoCLR>(20);
                for (int i = 0; i < 20; i++)
                {
                    list.Add(new VSensorLaserCameraInfoCLR());
                }
                int num = 0;
                VSensor.GetDeviceList(ref list, ref num);
                for (int i = 0; i < num; i++)
                {
                    Console.WriteLine("device num {0} : list[{1}] = {2}\n", i, i, list[i].CameraName);
                }
                //连接第一台设备
                int status = VSensor.DeviceConnect(0);
                if (status != 0)
                {
                    Console.WriteLine("connect device failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设置曝光时间
                status = VSensor.SetExposureTime(2.0);
                if (status != 0)
                {
                    Console.WriteLine("set exposure time failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设置投影等级
                status = VSensor.SetProjectLight(1);
                if (status != 0)
                {
                    Console.WriteLine("set project light failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设置去离散
                status = VSensor.SetOutlierDetect(2, 2.0f, true);
                if (status != 0)
                {
                    Console.WriteLine("set outlier detect failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设置降采样
                status = VSensor.SetDownsampling(2.0f, true);
                if (status != 0)
                {
                    Console.WriteLine("set downsampling failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设置滤波1
                status = VSensor.SetFilter1(2, true);
                if (status != 0)
                {
                    Console.WriteLine("set filter1 failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                /*
                //设置滤波2
                status = VSensor.SetFilter2(2, true);
                if (status != 0)
                {
                    Console.WriteLine("set filter2 failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                */
                //设置为采集模式
                status = VSensor.SetCaptureMode(1);
                if (status != 0)
                {
                    Console.WriteLine("set capture mode failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //单次采集测试
                Console.WriteLine("single restruction ...\n");
                status = VSensor.SingleRestruction(0);
                if (status != 0)
                {
                    Console.WriteLine("single restruction failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //获取当前相机输出分辨率
                int width = 0, height = 0;
                VSensor.GetImageResolution(ref width, ref height);
                VSensorLaserResultCLR result = new VSensorLaserResultCLR(width, height);
                VSensor.GetRestructionResult(ref result);
                //保存点云为ply格式
                status = VSensor.Save3DCloud(path + @"\test.ply", result, 0);
                if (status != 0)
                {
                    Console.WriteLine("save 3D points failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //连续采集
                Console.WriteLine("start continuous capture...\n");
                VSensor.ContinuousRestructionStart(0);
                for (int i = 0; i < 10; i++)
                {
                    status = VSensor.CaptureFrame(1000);
                    VSensor.GetRestructionResult(ref result);
                    Console.WriteLine("{0}   num =  {1}    ret:{2}\n", i + 1, result.nPointNum, status);
                    string varString = Convert.ToString(i);
                    string str = path + @"\test" + varString + ".ply";
                    VSensor.Save3DCloud(str, result, 0);
                }
                VSensor.ContinuousRestructionStop();
                //反初始化设备
                status = VSensor.DeviceUnInit();
                if (status != 0)
                {
                    Console.WriteLine("device release failed, status = {0}\n", status);
                    Console.ReadLine();
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine($"ex:{ex}");
            }
            Console.WriteLine("run success");
            Console.ReadLine();
            Console.ReadKey();
        }
    }
}
